﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace _16DIFSample
{
    public partial class Form1 : Form
    {
        short DevId;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //***フォームの表示開始時の初期化処理***
            Function_Enable(false); //***
            IDNUM.SelectedIndex = 0; //***初期選択IDを0にする
        }
        private void Function_Enable(Boolean en)
        {
            //***オープンとID選択ボタンのみを無効にする。***
            DevOpen.Enabled = !en; //***オープンボタン無効
            DevClose.Enabled = en; //***クローズボタン有効
            IDNUM.Enabled = !en; //***ID選択ボタン無効
            //***以下のボタンすべて有効
            LowDir.Enabled = en;
            HighDir.Enabled = en;
            LowRead.Enabled = en;
            HighRead.Enabled = en;
            LowWrite.Enabled = en;
            HighWrite.Enabled = en;
            WordRead.Enabled = en;
            WordWrite.Enabled = en;
        }

        private void DevOpen_Click(object sender, EventArgs e)
        {
            short retErr;
            //***デバイスのオープン***
            DevId = (short) IDNUM.SelectedIndex;
            retErr = TUSBDIF.Tusbdif_Device_Open(DevId);
            if (retErr == 0)
                Function_Enable(true); //***各機能ボタンを有効にする
            else
                MessageBox.Show(TUSBDIF.GetErrMessage(retErr)); //***オープンに失敗した場合
        }
        //***デバイスのクローズ***
        private void DevCloseEx()
        {
            TUSBDIF.Tusbdif_Device_Close(DevId); //***デバイスクローズ
            Function_Enable(false); //***ボタンの有効無効切り替え
        }

        private void DevClose_Click(object sender, EventArgs e)
        {
            DevCloseEx();
        }

        //***下位バイトの入出力方向設定
        private void LowDir_Click(object sender, EventArgs e)
        {
            short retErr;
            byte Dir;
            BitPatternSet InputDlg = new BitPatternSet();

            Dir = 0;
            if (InputDlg.GetLowByte(ref Dir, "出力ビットをチェックして下さい"))
            {
                retErr = TUSBDIF.Tusbdif_Low_Dir(DevId, Dir);
                if (retErr != 0) //***DLL関数の実行
                {
                    MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                    DevCloseEx();
                }
            }
        }

        //***上位バイトの入出力方向設定
        private void HighDir_Click(object sender, EventArgs e)
        {
            short retErr;
            byte Dir;
            BitPatternSet InputDlg = new BitPatternSet();

            Dir = 0;
            if (InputDlg.GetHighByte(ref Dir, "出力ビットをチェックして下さい"))
            {
                retErr = TUSBDIF.Tusbdif_High_Dir(DevId, Dir);
                if (retErr != 0) //***DLL関数の実行
                {
                    MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                    DevCloseEx();
                }
            }
        }

        //***下位バイトの出力
        private void LowWrite_Click(object sender, EventArgs e)
        {
            short retErr;
            byte Data;
            BitPatternSet InputDlg = new BitPatternSet();

            retErr = TUSBDIF.Tusbdif_LowByte_Read(DevId, out Data);
            if (retErr != 0)
            {
                MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                DevCloseEx();
            }

            if (InputDlg.GetLowByte(ref Data, "チェックビットがHighになります"))
            {
                retErr = TUSBDIF.Tusbdif_LowByte_Write(DevId, Data);
                if (retErr != 0) //***DLL関数の実行
                {
                    MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                    DevCloseEx();
                }
            }
        }

        //***上位バイトの出力
        private void HighWrite_Click(object sender, EventArgs e)
        {
            short retErr;
            byte Data;
            BitPatternSet InputDlg = new BitPatternSet();

            retErr = TUSBDIF.Tusbdif_HighByte_Read(DevId, out Data);
            if (retErr != 0)
            {
                MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                DevCloseEx();
            }

            if (InputDlg.GetHighByte(ref Data, "チェックビットがHighになります"))
            {
                retErr = TUSBDIF.Tusbdif_HighByte_Write(DevId, Data);
                if (retErr != 0) //***DLL関数の実行
                {
                    MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                    DevCloseEx();
                }
            }
        }

        //***下位バイトの入力データの取得
        private void LowRead_Click(object sender, EventArgs e)
        {
            short retErr;
            byte Data;
            BitPatternDisp DispDlg = new BitPatternDisp();

            retErr = TUSBDIF.Tusbdif_LowByte_Read(DevId, out Data);
            if (retErr != 0)
            {
                MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                DevCloseEx();
            }
            else
                DispDlg.DispLowByte(Data, "Hは入力High,Lは入力Lowです");
        }

        //***上位バイトの入力データの取得
        private void HighRead_Click(object sender, EventArgs e)
        {
            short retErr;
            byte Data;
            BitPatternDisp DispDlg = new BitPatternDisp();

            retErr = TUSBDIF.Tusbdif_HighByte_Read(DevId, out Data);
            if (retErr != 0)
            {
                MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                DevCloseEx();
            }
            else
                DispDlg.DispHighByte(Data, "Hは入力High,Lは入力Lowです");
        }

        //***ワード出力
        private void WordWrite_Click(object sender, EventArgs e)
        {
            short retErr;
            int Data;
            BitPatternSet InputDlg = new BitPatternSet();

            retErr = TUSBDIF.Tusbdif_Word_Read(DevId, out Data);
            if (retErr != 0)
            {
                MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                DevCloseEx();
            }

            if (InputDlg.GetWord(ref Data, "チェックビットがHighになります"))
            {
                retErr = TUSBDIF.Tusbdif_Word_Write(DevId, Data);
                if (retErr != 0) //***DLL関数の実行
                {
                    MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                    DevCloseEx();
                }
            }
        }

        private void WordRead_Click(object sender, EventArgs e)
        {
            short retErr;
            int Data;
            BitPatternDisp DispDlg = new BitPatternDisp();

            retErr = TUSBDIF.Tusbdif_Word_Read(DevId, out Data);
            if (retErr != 0)
            {
                MessageBox.Show(TUSBDIF.GetErrMessage(retErr));
                DevCloseEx();
            }
            else
                DispDlg.DispWord(Data, "Hは入力High,Lは入力Lowです");
        }
    }
}
