﻿//-----------------------------------------------
//API for TUSB-16DIF Driver
//Visual C# Module
//
//Jan. 27 2014
//Copyright (C) 2014 Turtle Industry Co.,Ltd.
//-----------------------------------------------

using System.Runtime.InteropServices;


class TUSBDIF
{
     //API public static extern short declaration
    [DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdif_Device_Open(short Id);
    [DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbdif_Device_Close(short Id);
    [DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdif_High_Dir(short Id, byte dirR);
    [DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdif_Low_Dir(short Id, byte dirR);
    [DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdif_LowByte_Write(short Id, byte dat);
    [DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdif_HighByte_Write(short Id, byte dat);
    [DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdif_LowByte_Read(short Id, out byte dat);
    [DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdif_HighByte_Read(short Id, out byte dat);
    [DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdif_Word_Write(short Id, int dat);
    [DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdif_Word_Read(short Id, out int dat );
    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 8:
                return "パラメータエラーです";
            case 9:
                return "USB通信エラーです";
            default:
                return "不明なエラーです";
        }
    }
}

