﻿'-----------------------------------------------
'API for TUSB-16DIF Driver
'Visual Basic Module
'
'Jan. 27 2014
'Copyright (C) 2014 Turtle Industry Co.,Ltd.
'-----------------------------------------------

Imports System.Runtime.InteropServices

Module TUSBDIF
    'API Function declaration
    <DllImport("TUSBDIF.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdif_Device_Open(ByVal Id As Short) As Short
    End Function
    <DllImport("TUSBDIF.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Sub Tusbdif_Device_Close(ByVal Id As Short)
    End Sub
    <DllImport("TUSBDIF.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdif_High_Dir(ByVal id As Short, _
                              ByVal dirR As Byte) As Short
    End Function
    <DllImport("TUSBDIF.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdif_Low_Dir(ByVal id As Short, _
                             ByVal dirR As Byte) As Short
    End Function
    <DllImport("TUSBDIF.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdif_LowByte_Write(ByVal id As Short, _
                                   ByVal dat As Byte) As Short
    End Function
    <DllImport("TUSBDIF.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdif_HighByte_Write(ByVal id As Short, _
                                    ByVal dat As Byte) As Short
    End Function
    <DllImport("TUSBDIF.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdif_LowByte_Read(ByVal id As Short, _
                                  ByRef dat As Byte) As Short
    End Function
    <DllImport("TUSBDIF.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdif_HighByte_Read(ByVal id As Short, _
                                   ByRef dat As Byte) As Short
    End Function
    <DllImport("TUSBDIF.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdif_Word_Write(ByVal id As Short, _
                                ByVal dat As Integer) As Short
    End Function
    <DllImport("TUSBDIF.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdif_Word_Read(ByVal id As Short, _
                               ByRef dat As Integer) As Short
    End Function
    ' Error Message
    Public Sub Tusbdif_ErrorDisp(ByVal ErrCode As Short)
        Dim Message As String

        Select Case ErrCode
            Case 0
                Message = "正常に終了しました"
            Case 1
                Message = "ID番号が不正です"
            Case 2
                Message = "ドライバが初期化されていません"
            Case 3
                Message = "すでにデバイスはオープンされています"
            Case 4
                Message = "接続されている台数が多すぎます"
            Case 5
                Message = "オープンできませんでした"
            Case 6
                Message = "デバイスが見つかりませんでした"
            Case 8
                Message = "パラメータエラーです"
            Case 9
                Message = "USB通信エラーです"
            Case Else
                Message = "不明なエラーです"
        End Select

        MessageBox.Show(Message)
    End Sub
End Module
