﻿Public Class Form1
    Private DevId As Short

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        '***フォームの表示開始時の初期化処理***
        Function_Enable(False) '***
        IDNUM.SelectedIndex = 0 '***初期選択IDを0にする
    End Sub
    Private Sub Function_Enable(ByVal en As Boolean)
        '***オープンとID選択ボタンのみを無効にする。***
        DevOpen.Enabled = Not en '***オープンボタン無効
        DevClose.Enabled = en '***クローズボタン有効
        IDNUM.Enabled = Not en '***ID選択ボタン無効
        '***以下のボタンすべて有効
        LowDir.Enabled = en
        HighDir.Enabled = en
        LowRead.Enabled = en
        HighRead.Enabled = en
        LowWrite.Enabled = en
        HighWrite.Enabled = en
        WordRead.Enabled = en
        WordWrite.Enabled = en
    End Sub

    Private Sub DevOpen_Click(sender As System.Object, e As System.EventArgs) Handles DevOpen.Click
        Dim retErr As Short
        '***デバイスのオープン***
        DevId = IDNUM.SelectedIndex
        retErr = Tusbdif_Device_Open(DevId)
        If (retErr = 0) Then
            Function_Enable(True) '***各機能ボタンを有効にする
        Else
            Tusbdif_ErrorDisp(retErr)'***オープンに失敗した場合
        End If
    End Sub

    '***デバイスのクローズ***
    Private Sub DevCloseEx()
        Tusbdif_Device_Close(DevId) '***デバイスクローズ
        Function_Enable(False) '***ボタンの有効無効切り替え

    End Sub
    Private Sub DevClose_Click(sender As System.Object, e As System.EventArgs) Handles DevClose.Click
        DevCloseEx()
    End Sub

    '***下位バイトの入出力方向設定
    Private Sub LowDir_Click(sender As System.Object, e As System.EventArgs) Handles LowDir.Click
        Dim retErr As Short
        Dim Dir As Byte
        Dim InputDlg As New BitPatternSet

        Dir = 0
        If InputDlg.GetLowByte(Dir, "出力ビットをチェックして下さい") Then
            retErr = Tusbdif_Low_Dir(DevId, Dir)
            If retErr <> 0 Then
                Tusbdif_ErrorDisp(retErr)
                DevCloseEx()
            End If
        End If
    End Sub

    '***上位バイトの入出力方向設定
    Private Sub HighDir_Click(sender As System.Object, e As System.EventArgs) Handles HighDir.Click
        Dim retErr As Short
        Dim Dir As Byte
        Dim InputDlg As New BitPatternSet

        Dir = 0
        If InputDlg.GetHighByte(Dir, "出力ビットをチェックして下さい") Then
            retErr = Tusbdif_High_Dir(DevId, Dir)
            If retErr <> 0 Then
                Tusbdif_ErrorDisp(retErr)
                DevCloseEx()
            End If
        End If
    End Sub

    '***下位バイトの出力
    Private Sub LowWrite_Click(sender As System.Object, e As System.EventArgs) Handles LowWrite.Click
        Dim retErr As Short
        Dim Data As Byte
        Dim InputDlg As New BitPatternSet

        retErr = Tusbdif_LowByte_Read(DevId, Data)
        If retErr <> 0 Then
            Tusbdif_ErrorDisp(retErr)
            DevCloseEx()
        End If

        If InputDlg.GetLowByte(Data, "チェックビットがHighになります") Then
            retErr = Tusbdif_LowByte_Write(DevId, Data)
            If retErr <> 0 Then
                Tusbdif_ErrorDisp(retErr)
                DevCloseEx()
            End If
        End If
    End Sub

    '***上位バイトの出力
    Private Sub HighWrite_Click(sender As System.Object, e As System.EventArgs) Handles HighWrite.Click
        Dim retErr As Short
        Dim Data As Byte
        Dim InputDlg As New BitPatternSet

        retErr = Tusbdif_HighByte_Read(DevId, Data)
        If retErr <> 0 Then
            Tusbdif_ErrorDisp(retErr)
            DevCloseEx()
        End If

        If InputDlg.GetHighByte(Data, "チェックビットがHighになります") Then
            retErr = Tusbdif_HighByte_Write(DevId, Data)
            If retErr <> 0 Then
                Tusbdif_ErrorDisp(retErr)
                DevCloseEx()
            End If
        End If
    End Sub

    '***下位バイトの入力データの取得
    Private Sub LowRead_Click(sender As System.Object, e As System.EventArgs) Handles LowRead.Click
        Dim retErr As Short
        Dim Data As Byte
        Dim DispDlg As New BitPatternDisp

        retErr = Tusbdif_LowByte_Read(DevId, Data)
        If retErr <> 0 Then
            Tusbdif_ErrorDisp(retErr)
            DevCloseEx()
        Else
            DispDlg.DispLowByte(Data, "Hは入力High,Lは入力Lowです")
        End If
    End Sub

    '***上位バイトの入力データの取得
    Private Sub HighRead_Click(sender As System.Object, e As System.EventArgs) Handles HighRead.Click
        Dim retErr As Short
        Dim Data As Byte
        Dim DispDlg As New BitPatternDisp

        retErr = Tusbdif_HighByte_Read(DevId, Data)
        If retErr <> 0 Then
            Tusbdif_ErrorDisp(retErr)
            DevCloseEx()
        Else
            DispDlg.DispHighByte(Data, "Hは入力High,Lは入力Lowです")
        End If
    End Sub

    '***ワード出力
    Private Sub WordWrite_Click(sender As System.Object, e As System.EventArgs) Handles WordWrite.Click
        Dim retErr As Short
        Dim Data As Integer
        Dim InputDlg As New BitPatternSet

        retErr = Tusbdif_Word_Read(DevId, Data)
        If retErr <> 0 Then
            Tusbdif_ErrorDisp(retErr)
            DevCloseEx()
        End If

        If InputDlg.GetWord(Data, "チェックビットがHighになります") Then
            retErr = Tusbdif_Word_Write(DevId, Data)
            If retErr <> 0 Then
                Tusbdif_ErrorDisp(retErr)
                DevCloseEx()
            End If
        End If
    End Sub

    '***入力ワードデータの取得
    Private Sub WordRead_Click(sender As System.Object, e As System.EventArgs) Handles WordRead.Click
        Dim retErr As Short
        Dim Data As Integer
        Dim DispDlg As New BitPatternDisp

        retErr = Tusbdif_Word_Read(DevId, Data)
        If retErr <> 0 Then
            Tusbdif_ErrorDisp(retErr)
            DevCloseEx()
        Else
            DispDlg.DispWord(Data, "Hは入力High,Lは入力Lowです")
        End If
    End Sub
End Class
